﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;

namespace wiipermpair
{
    public partial class Form1 : Form
    {
        const int BLUETOOTH_MAX_NAME_SIZE = 248;
        [StructLayout(LayoutKind.Sequential)]
        struct BLUETOOTH_FIND_RADIO_PARAMS
        {
            public uint dwSize;
        }
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        struct BLUETOOTH_RADIO_INFO
        {
            public uint dwSize;
            public BLUETOOTH_ADDRESS address;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = BLUETOOTH_MAX_NAME_SIZE)]
            public string szName;
            public UInt32 ulClassofDevice;
            public UInt16 lmpSubversion;
            public UInt16 manufacturer;
        }
        [StructLayout(LayoutKind.Explicit)]
        unsafe struct BLUETOOTH_ADDRESS
        {
            [FieldOffset(0)]
            public UInt64 ullLong;
            [FieldOffset(0)]
            public fixed byte rgBytes[6];
        }
        [StructLayout(LayoutKind.Sequential)]
        struct BLUETOOTH_DEVICE_SEARCH_PARAMS
        {
            public uint dwSize;
            public bool fReturnAuthenticated;
            public bool fReturnRemembered;
            public bool fReturnUnknown;
            public bool fReturnConnected;
            public bool fIssueInquiry;
            public byte cTimeoutMultiplier;
            public IntPtr hRadio;
        }
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        struct BLUETOOTH_DEVICE_INFO
        {
            public uint dwSize;
            public BLUETOOTH_ADDRESS Address;
            public uint ulClassofDevice;
            public bool fConnected;
            public bool fRemembered;
            public bool fAuthenticated;
            public SYSTEMTIME stLastSeen;
            public SYSTEMTIME stLastUsed;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = BLUETOOTH_MAX_NAME_SIZE)]
            public string szName;
        }
        [StructLayout(LayoutKind.Sequential)]
        public struct SYSTEMTIME
        {
            public Int16 wYear;
            public Int16 wMonth;
            public Int16 wDayOfWeek;
            public Int16 wDay;
            public Int16 wHour;
            public Int16 wMinute;
            public Int16 wSecond;
            public Int16 wMilliseconds;
        }

        const UInt32 BLUETOOTH_SERVICE_DISABLE = 0x00;
        const UInt32 BLUETOOTH_SERVICE_ENABLE = 0x01;
        static Guid HumanInterfaceDeviceServiceClass_UUID =
            new Guid(0x00001124, 0x0000, 0x1000, 0x80, 0x00, 0x00, 0x80, 0x5F, 0x9B, 0x34, 0xFB);

        [DllImport("mybthprops.dll")]
        extern static IntPtr MyBluetoothFindFirstRadio(
         ref BLUETOOTH_FIND_RADIO_PARAMS btfrp,
         out IntPtr hRadio
        );
        [DllImport("mybthprops.dll")]
        extern static bool MyBluetoothFindNextRadio(
            IntPtr hFind,
            out IntPtr hRadio
        );
        [DllImport("mybthprops.dll", CallingConvention = CallingConvention.Cdecl)]
        extern static UInt32 MyBluetoothGetRadioInfo(
            IntPtr hRadio,
            ref BLUETOOTH_RADIO_INFO pRadioInfo
        );
        [DllImport("mybthprops.dll", CallingConvention = CallingConvention.Cdecl)]
        extern static UInt32 MyBluetoothFindRadioClose(IntPtr hFind);
        [DllImport("mybthprops.dll", CallingConvention = CallingConvention.Cdecl)]
        extern static IntPtr MyBluetoothFindFirstDevice(
            ref BLUETOOTH_DEVICE_SEARCH_PARAMS btsp,
            ref BLUETOOTH_DEVICE_INFO btdi
            );
        [DllImport("mybthprops.dll", CallingConvention = CallingConvention.Cdecl)]
        extern static bool MyBluetoothFindNextDevice(
            IntPtr hFind,
            ref BLUETOOTH_DEVICE_INFO btdi
        );
        [DllImport("mybthprops.dll", CallingConvention = CallingConvention.Cdecl)]
        extern static bool MyBluetoothFindDeviceClose(IntPtr hFind);
        [DllImport("mybthprops.dll", CallingConvention = CallingConvention.Cdecl)]
        extern static bool MyCloseHandle(IntPtr hObj);
        [DllImport("mybthprops.dll", CallingConvention = CallingConvention.Cdecl)]
        extern static UInt32 MyBluetoothRemoveDevice(ref BLUETOOTH_ADDRESS address);
        [DllImport("mybthprops.dll", CallingConvention = CallingConvention.Cdecl)]
        extern static UInt32 MyBluetoothSetServiceState(
            IntPtr hRadio,
            ref BLUETOOTH_DEVICE_INFO btdi,
            ref Guid GUIDService,
            UInt32 dwServiceFlags
        );
        [DllImport("mybthprops.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        extern static UInt32 MyBluetoothAuthenticateDevice(
                        IntPtr hwnd, IntPtr hRadio, ref BLUETOOTH_DEVICE_INFO btdi,
                        char[] passkey, UInt32 passkeylen);

        [DllImport("mybthprops.dll", CallingConvention = CallingConvention.Cdecl)]
        extern static UInt32 MyBluetoothEnumerateInstalledServices(
            IntPtr hRadio, ref BLUETOOTH_DEVICE_INFO btdi,
            ref UInt32 pcServices, Guid[] pGuidServices);


        IntPtr hradio = IntPtr.Zero;
        BLUETOOTH_RADIO_INFO rinfo = new BLUETOOTH_RADIO_INFO();
        List<BLUETOOTH_DEVICE_INFO> btdis = new List<BLUETOOTH_DEVICE_INFO>();

        public Form1()
        {
            InitializeComponent();

            radio_search();
        }

        private unsafe void radio_search()
        {
            IntPtr hrfind;

            BLUETOOTH_FIND_RADIO_PARAMS param = new BLUETOOTH_FIND_RADIO_PARAMS();
            param.dwSize = (UInt32)Marshal.SizeOf(param);
            if ((hrfind = MyBluetoothFindFirstRadio(ref param, out hradio)) != IntPtr.Zero)
            {
                rinfo.dwSize = (UInt32)Marshal.SizeOf(rinfo);
                MyBluetoothGetRadioInfo(hradio, ref rinfo);
                fixed (byte* addrbyte = rinfo.address.rgBytes)
                {

                    label1.Text = string.Format("bluetooth host = {5:X02}:{4:X02}:{3:X02}:{2:X02}:{1:X02}:{0:X02}",
                        addrbyte[0], addrbyte[1], addrbyte[2], addrbyte[3], addrbyte[4], addrbyte[5]);
                }
            }
            else
            {
                label1.Text = "no bluetooth module";// MessageBox.Show("findfirst fail.");
            }
            MyBluetoothFindRadioClose(hrfind);
        }

        private unsafe void button1_Click(object sender, EventArgs e)
        {
            if (hradio == IntPtr.Zero) return;
            BLUETOOTH_DEVICE_INFO btdi = new BLUETOOTH_DEVICE_INFO();
            BLUETOOTH_DEVICE_SEARCH_PARAMS srch = new BLUETOOTH_DEVICE_SEARCH_PARAMS();

            btdi.dwSize = (uint)Marshal.SizeOf(btdi);
            srch.dwSize = (uint)Marshal.SizeOf(srch);

            srch.fReturnAuthenticated = true;
            srch.fReturnRemembered = true;
            srch.fReturnConnected = true;
            srch.fReturnUnknown = true;
            srch.fIssueInquiry = true;
            srch.cTimeoutMultiplier = 2;
            srch.hRadio = hradio;

            listBox1.Items.Clear();
            btdis.Clear();
            IntPtr hfind = MyBluetoothFindFirstDevice(ref srch, ref btdi);
            while (hfind != IntPtr.Zero)
            {
                btdis.Add(btdi);
                listBox1.Items.Add(string.Format("{0} ({1:X02}:{2:X02}:{3:X02}:{4:X02}:{5:X02}:{6:X02}), auth:{7}, conn:{8}, rem:{9}",
                    btdi.szName,
                    btdi.Address.rgBytes[5], btdi.Address.rgBytes[4], btdi.Address.rgBytes[3],
                    btdi.Address.rgBytes[2], btdi.Address.rgBytes[1], btdi.Address.rgBytes[0],
                    btdi.fAuthenticated, btdi.fConnected, btdi.fRemembered));

                btdi = new BLUETOOTH_DEVICE_INFO();
                btdi.dwSize = (uint)Marshal.SizeOf(btdi);

                if (!MyBluetoothFindNextDevice(hfind, ref btdi)) break;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (hradio == IntPtr.Zero) return;
            if (listBox1.SelectedIndex < 0) return;
            if (!((string)listBox1.SelectedItem).StartsWith("Nintendo"))
            {
                MessageBox.Show((string)listBox1.SelectedItem + " is not wiimote device");
                return;
            }

            paring(btdis[listBox1.SelectedIndex]);
        }

        unsafe void paring(BLUETOOTH_DEVICE_INFO btdi)
        {
            UInt32 ret = 0;
            if (btdi.fRemembered)
            {
                ret = MyBluetoothRemoveDevice(ref btdi.Address);
            }
            if (ret != 0)
            {
                MessageBox.Show("remove error.");
                return;
            }

            char[] pass = new char[6];
            fixed (byte* addr = rinfo.address.rgBytes)
            {
                for (int i = 0; i < 6; i++) pass[i] = (char)addr[i];
            }
            ret = MyBluetoothAuthenticateDevice(IntPtr.Zero, hradio, ref btdi, pass, 6);
            if (ret != 0)
            {
                MessageBox.Show("auth error. " + ret);
                return;
            }

            ret = MyBluetoothSetServiceState(hradio, ref btdi,
                ref HumanInterfaceDeviceServiceClass_UUID, BLUETOOTH_SERVICE_ENABLE);
            if (ret != 0)
            {
                MessageBox.Show("set service enable error");
                return;
            }
        }
    }
}
